// GLWVideo.h: interface for the GLWVideo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GLWVIDEO_H__D4BB2154_9DC5_401E_9E0E_2320B438651E__INCLUDED_)
#define AFX_GLWVIDEO_H__D4BB2154_9DC5_401E_9E0E_2320B438651E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class GLWVideo  
{
public:
	GLWVideo();
	virtual ~GLWVideo();
	
public:
	GLWVideo(float ral, int x, int y, int bits);
	int InitWorld(char *s);  // ritorna TRUE se tutte le operazioni sono state svolte correttamente	
	int Disegna(GLvoid);       // ritorna TRUE se il gioco deve terminare
	GLvoid ReSizeGLScene(GLsizei width, GLsizei height);		// Ridimensiona e Inizializza la Finestra GL 
	GLvoid KillGLWindow(GLvoid);								// Distrugge in modo corretto la finestra

	char *Wnd_Name;

	/* collisioni */
		GLvoid controlla_collisione();
		double max_vertex(double *v, int n);
		double min_vertex(double *v, int n);

	/* gravit */
		GLvoid gravita(GLvoid);

	/* variabili riguardanti i movimenti del personaggio */
		int avanti, giu;
		int max_avanti;//, max_destra; // giu non ha velocit massima
		
public:	
//	bool	active;				// Flag di Finestra Attiva, settato a TRUE di default
	bool	fullscreen;			// Flag di Schermo Intero settato alla modalit Schermo Intero di default
	bool	blend;				// Blending ON/OFF
	
	float Rallentamento;  //***
	int Screen_X;
	int Screen_Y;
	int Screen_BITS;

	int texture_vittoria; // indice della texture di vittoria

	/* testo */
		GLuint	base;				// Display List di base per il set di caratteri
		GLfloat	cnt1;				// 1 contatore usato per muovere il Testo e per il Colore
		GLfloat	cnt2;				// 2 contatore usato per muovere il Testo e per il Colore

		GLvoid BuildFont(GLvoid);	// Costruisce il nostro Font Bitmap 
		GLvoid KillFont(GLvoid);	// Cancella le Font List
		GLvoid glPrint(const char *fmt, ...); // Funzione GL "Print" personalizzata
		GLvoid scrivi(const char *fmt, ...);  // stampa a video del testo

private:
	void readstr(FILE *f,char *string);
	AUX_RGBImageRec *LoadBMP(char *Filename);	// Carica un'immagine Bitmap 
	int LoadGLTextures();
	int AddTexture(char *nome_file);
	GLvoid InitTextureVittoria(GLvoid); // salva in texture_vittoria l'indice della texture in contatto con la quale si vince
	void SetupWorld();			
	int InitGL(GLvoid);										// Tutti i settaggi per OpenGL vengono fatti qui
	int DrawGLScene(GLvoid);									// Qui  dove farete tutti i disegni		
	BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag);

	bool	bp;					// Il tasto B  premuto?
	bool	lp;					// Il tasto L  premuto?
	bool	fp;					// Il tasto F  premuto? // fps
};


#endif // !defined(AFX_GLWVIDEO_H__D4BB2154_9DC5_401E_9E0E_2320B438651E__INCLUDED_)
