/*
	Non  stato un lavoro facile reimpostare il codice della Lesson10 della guida OpenGL
	di NeHe, c' voluto parecchio tempo per capire cosa convenisse fare e per correggere 
	tutti gli errori. Il codice realizzato mi sembra il pi comprensibile possibile, 
	tenendo conto che da qui in poi il progetto diverr sempre pi complicato 
																 Oligoatria - 03_01_2007

	Il progetto non si  ancora esaurito; i prossimi punti che voglio implementare sono
	la gestione delle luci, di suoni compressi, di pi suoni contemporaneamente, migliorare
	la gestione degli fps, fino ad arrivare al caricamento di modelli 3D, che comporter
	inoltre una migliore gestione delle collisioni, fino ad ora poco curate e basate su cubi.
																 Oligoatria - 02_02_2007
*/

#include <windows.h>		// File d'Intestazione per Windows
#include <math.h>			// File d'Intestazione per la libreria Matematica
#include <stdio.h>			// File d'Intestazione per Standard Input/Output
#include <stdarg.h>			// File d'Intestazione per le funzioni con argomenti variabili (aggiunto per il testo)
#include <gl\gl.h>			// File d'Intestazione per la libreria OpenGL32 
#include <gl\glu.h>			// File d'Intestazione per la libreria GLu32 
#include <gl\glaux.h>		// File d'Intestazione per la libreria Glaux 

#include "GLWVideo.h"

/* costanti comode in fase di sviluppo, ma che non dovranno esserci nella stable */
	int ral = 25;
	int SCREEN_X     = 1024;
	int SCREEN_Y     = 768;
	int SCREEN_BITS  = 16;
	
/* Variabili chiave dell'applicazione */
	HDC			hDC=NULL;		// Device Context GDI privato
	HGLRC		hRC=NULL;		// Rendering Context permanente
	HWND		hWnd=NULL;		// Handle alla Finestra 
	HINSTANCE	hInstance;		// Istanza dell'Applicazione

	bool	keys[256];			// Array usato per la routine della tastiera
	bool	active=TRUE;		// Flag di Finestra Attiva, settato a TRUE di default

/* Movimento del soggetto */
	float	heading;
	float	xpos;
	float	zpos;
	float   ypos;
	
	GLfloat	yrot;				// Rotazione Y 
	GLfloat walkbias;
	GLfloat walkbiasangle;
	GLfloat lookupdown;
	GLfloat	z;				    // Profondit nello Schermo

/* Visuale (camera) */
	void Mouse_move();

/* variabili di gioco */
	int vittoria;  // 0 niente, -1 sconfitta, 1 vittoria (l'uscita  considerata come sconfitta */
	int vel_gra = 6;

/* Classe GLWVideo */
	GLWVideo *Screen;			// svolge le operazioni principali che richiamano l'OpenGL

/* Collisioni */
	const int INTERVALLO_COLLISIONI=1; // per velocizzare il ciclo di gioco si eseguono solo i controlli essenziali con la frequenza 
	                                  //minima al corretto funzionamento dell'applicazione
	const int INTERVALLO_GRAVITA=0;
	int collidono;  // -1 se collidono,  1 se non c' contatto
	int suolo; // 1 se tocca il suolo

	
/* fps */
	int fps;        // devono essere 60
	int count_fps;
	const int FPS_DELTA = 2;// = 0.1s  // l'intervallo di tolleranza per la fps
	const int FPS_VOLUTI = 60;
	const int FPS_LIMITE_MODIFICA = 0;

/* Suoni */
	const int TEMPO_EFFETTO1=200;

/* prototipo metodi globali */
	void FPS(); // Calcolo le fps
	LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Prototipo di funzione per WndProc // gestisce le chiamate di sistema


int WINAPI WinMain(	HINSTANCE	hInstance,			// Istanza
					HINSTANCE	hPrevInstance,		// Istanza precedente
					LPSTR		lpCmdLine,			// Parametri della linea di comando
					int			nCmdShow)			// Stato di display della Finestra (Show State)
{
	
	/* Creo l'oggetto principale della visualizzazione video */
		Screen = new GLWVideo(ral, SCREEN_X, SCREEN_Y, SCREEN_BITS);

	/* Chiede utente se vuole il fullscreen */
		if (MessageBox(NULL,"Schermo intero?", "Start FullScreen?",MB_YESNO|MB_ICONQUESTION)==IDNO)
		{
			Screen->fullscreen=FALSE;							// Modalit finestra
		}	

	/* Variabili del ciclo di gioco */			
		MSG		msg;									// Struttura Windows Message 
		BOOL	done=FALSE;								// Variabile Bool per uscire dal ciclo
	
	/* Inizializzo il mondo 3D */
		if (!Screen->InitWorld("The Huge Labyrinth"))
			return 0;

	/* Ciclo di gioco */
		int coll=0;     // controlla le collisioni ogni INTERVALLO_COLLISIONI
		int gra=0;      // la gravit agisce ogni INTERVALLO_GRAVITA
		
	/* Start colonna sonora */
		sndPlaySound("Data/Sounds/Sottofondo.wav", SND_NOSTOP|SND_LOOP|SND_ASYNC|SND_FILENAME);

	/* fps */
		int i;
		long tempo=timeGetTime(), ttempo; // restituisce il time di sistema (windows) in millisecondi		
		long attesa;
		count_fps=0;
		int msSleep=90000; // attesa ad ogni ciclo		
		int modifica=0;    // variabile per attutire gli sbalzi di velocit
			
		ShowCursor(false);

		while(!done)									// Ciclo che si ripete finch done=FALSE
		{	
			if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// C' un messaggio in attesa?
			{
				if (msg.message==WM_QUIT)				// Abbiamo ricevuto un messaggio di chiusura?
				{
					done=TRUE;							// Se s, done=TRUE
				}
				else									// Se no, gestisci i messaggi Window 
				{
					TranslateMessage(&msg);				// Traduce il Messaggio
					DispatchMessage(&msg);				// Invia il Messaggio
				}
			}
			else										// Se non ci sono messaggi
			{
				/* gestione fps */			
					Mouse_move();

					if (count_fps==6) // controllo quanto tempo  trascorso e regolo ral in funzione di esso
					{					
						ttempo=timeGetTime();
						attesa=ttempo-tempo;
						tempo=ttempo;
						
						count_fps=0;
						fps= (int) (1000 * 6) / attesa; // proporzione --> attesa : 6 = 1000ms : fps
						
						if (fps>FPS_VOLUTI+FPS_DELTA)  // se  troppo lento
						{
							if (modifica++>FPS_LIMITE_MODIFICA)
								msSleep+=8000;
						}
						else if (fps<FPS_VOLUTI-FPS_DELTA)  // se il programma v troppo veloce
						{
							if (modifica++>FPS_LIMITE_MODIFICA)
								msSleep-=8000;
						}
						else modifica=0;

								
					}
					count_fps++;
					FPS();

				/* Collisioni */				
					coll++;
					if (coll==INTERVALLO_COLLISIONI)
					{
						coll=0;
						// eseguo i controlli delle collisioni // per ora grossolani
							
							// consideriamo come nostro spazio 0.25, 0.25, 0.25 simmetrico (escluso z: 0 - 0.25)
							Screen->controlla_collisione();
						
					}

				/* Gravit */
					Screen->gravita();					
				
				/* Disegno */
					// Disegna la scena. Controlla il tasto ESC e i messaggi di chiusura dalla DrawGLScene()		
					done = Screen->Disegna();					
			}			

			if (vittoria==1)  // gestione della vittoria
			{
				done=1;
			}
			
			for (i=0; i<msSleep; i++) ttempo=strcmp("sss","ssssssss");
		}


	/* Chiusura */
		Screen->KillGLWindow();							// Distrugge la Finestra
		delete Screen;                                  // dealloca la variabile Screen

		return (msg.wParam);							// Esce dal programma
}

void Mouse_move()
{
	POINT mousePos;	
	int mid_x = SCREEN_X  >> 1;	
	int mid_y = SCREEN_Y  >> 1;	
	float angle_y  = 0.0f;				
	float angle_z  = 0.0f;							
	
	GetCursorPos(&mousePos);					
	
//	if( (mousePos.x == mid_x) && (mousePos.y == mid_y) ) return; // se il mouse  fermo  // omesso, per il momento, cos da averem meno sbalzi di velocit

	SetCursorPos(mid_x, mid_y);	// mouse impostato al centro dello schermo

	// calcolo quanto  stato mosso il mouse
	angle_y = (float)( (mid_x - mousePos.x) ) / 1000;		
	angle_z = (float)( (mid_y - mousePos.y) ) / 1000;

	if (((lookupdown-angle_z*100)<40)&&((lookupdown-angle_z*100)>-40))
		lookupdown+=-angle_z*100;

	yrot+=angle_y*100;				
	heading=yrot;
}

LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle per questa Finestra
									UINT	uMsg,			// Messaggio per questa Finesta
									WPARAM	wParam,			// Ulteriori Informazioni sul messaggio
									LPARAM	lParam)			// Ulteriori Informazioni sul messaggio
							
{
	switch (uMsg)									// Testa i messaggi di Windows 
	{
		case WM_ACTIVATE:							// Tratta il messaggio di attivazione finestra 
		{
			if (!HIWORD(wParam))					// Testa per lo stato di riduzione a icona
			{
				active=TRUE;						// Il programma  attivo
			}
			else
			{
				active=FALSE;						// Il programma non  attivo
			}

			return 0;								// Ritorna al ciclo dei messaggi 
		}

		case WM_SYSCOMMAND:							// Intercetta i comandi di sistema
		{
			switch (wParam)							// Testa per chiamate di sistema
			{
				case SC_SCREENSAVE:					// Il salvaschermo sta provando a partire?
				case SC_MONITORPOWER:				// Il Monitor sta provando ad andare in stand-by?
				return 0;							// Evita gli eventi
			}
			break;									// Esci
		}

		case WM_CLOSE:								// E' stato ricevuto un messaggio di chiusura?
		{
			PostQuitMessage(0);						// Manda un messaggio Quit (chiudi)
			return 0;								// Ritorna
		}

		case WM_KEYDOWN:							// E' stato premuto un tasto?
		{
			keys[wParam] = TRUE;					// Se si, lo marca a TRUE
			return 0;								// Ritorna
		}

		case WM_KEYUP:								// E' stato rilasciato un tasto?
		{
			keys[wParam] = FALSE;					// Se si, lo marca a FALSE
			return 0;								// Ritorna
		}

		case WM_SIZE:								// Ridimensiona la Finestra OpenGL 
		{		
			Screen->ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Larghezza, HiWord=Altezza			
			return 0;								// Ritorna
		}
	}

	// Passa tutti i messaggi non gestiti a DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

void FPS()					// Calcolo le fps
{
	static float fps           = 0.0f;						
    static float previousTime  = 0.0f;	
	static char  strFPS[20]    = {0};
	
	float currentTime = (GetTickCount() * 0.001f);				

    ++fps;	

    if( currentTime - previousTime > 1.0f )
    {
	    previousTime = currentTime;
		sprintf(strFPS, "FPS: %d", int(fps));
		SetWindowText(hWnd, strFPS);
        fps = 0.0f;
    }
}